#color pick
execute unless entity @e[tag=spawn,tag=gamestarted] run function boxrush:colorpick/colorpick

#cooldown
execute as @e[tag=spawn,tag=cooldown] run scoreboard players add @s cooldown 1
execute as @e[tag=cooldown,scores={cooldown=1}] run title @a subtitle {"text":"Game starting in a few seconds","color":"dark_green"}
execute as @e[tag=cooldown,scores={cooldown=1}] run title @a title {"text":"Boxes Loading...","color":"green","bold":true}
execute as @e[tag=cooldown,scores={cooldown=1}] as @a at @s run playsound block.note_block.hat voice @s ~ ~ ~ 1 1
execute as @e[tag=cooldown,scores={cooldown=1}] run function boxrush:boxsetup/boxpick
execute as @e[tag=cooldown,scores={cooldown=200}] run function boxrush:start
execute as @e[tag=cooldown,scores={cooldown=200}] run tag @a[team=!spec,team=!] add ingame
execute as @e[tag=cooldown,scores={cooldown=240}] run title @a title {"text":"Game starting in","color":"dark_red","bold":true}
execute as @e[tag=cooldown,scores={cooldown=260}] run title @a title {"text":"3","color":"red","bold":true}
execute as @e[tag=cooldown,scores={cooldown=260}] as @a at @s run playsound block.note_block.pling voice @s ~ ~ ~ 1 1 
execute as @e[tag=cooldown,scores={cooldown=280}] run title @a title {"text":"2","color":"gold","bold":true}
execute as @e[tag=cooldown,scores={cooldown=280}] as @a at @s run playsound block.note_block.pling voice @s ~ ~ ~ 1 1
execute as @e[tag=cooldown,scores={cooldown=300}] run title @a title {"text":"1","color":"yellow","bold":true}
execute as @e[tag=cooldown,scores={cooldown=300}] as @a at @s run playsound block.note_block.pling voice @s ~ ~ ~ 1 1
execute as @e[tag=cooldown,scores={cooldown=320}] run title @a title {"text":"GO!","color":"green","bold":true}
execute as @e[tag=cooldown,scores={cooldown=320}] as @a at @s run playsound block.note_block.pling voice @s ~ ~ ~ 1 2
execute as @e[tag=cooldown,scores={cooldown=320}] run tag @e[tag=spawn] add gamestarted
execute as @e[tag=cooldown,scores={cooldown=320}] run function boxrush:glassclear
execute as @e[tag=cooldown,scores={cooldown=320}] run tag @s remove cooldown
execute as @e[scores={cooldown=320}] run scoreboard players reset @s cooldown

#checkpoint
execute at @e[tag=checkpoint,tag=cp1] as @a[gamemode=adventure,tag=!cp1,distance=..1.8] run function boxrush:checkpoints/checkpoint1
execute at @e[tag=checkpoint,tag=cp2] as @a[gamemode=adventure,tag=!cp2,distance=..1.8] run function boxrush:checkpoints/checkpoint2

execute at @e[tag=checkpoint] run kill @e[type=ender_pearl,distance=..2]

#death
execute as @a[gamemode=adventure] at @s if block ~ ~-1 ~ black_concrete run kill @s

#timer
execute as @a[tag=ingame] run scoreboard players add @s ticks 1
execute as @a[tag=ingame,scores={ticks=20}] run scoreboard players add @s sec 1
execute as @a[tag=ingame,scores={ticks=20}] run scoreboard players set @s ticks 0
execute as @a[tag=ingame,scores={sec=60}] run scoreboard players add @s min 1
execute as @a[tag=ingame,scores={sec=60}] run scoreboard players set @s sec 0

#finish line
execute as @a[tag=ingame] at @s if block ~ ~-1 ~ black_terracotta run function boxrush:finish

#endgame
execute store result score @e[tag=spawn] ingameplyrs if entity @a[tag=ingame]
execute as @e[tag=spawn,tag=gamestarted,scores={ingameplyrs=0}] run schedule function boxrush:endgame 3s append
execute as @e[tag=spawn,tag=gamestarted,scores={ingameplyrs=0}] run title @a title {"text":"Game Ended!","color":"green","bold":true}
execute as @e[tag=spawn,tag=gamestarted,scores={ingameplyrs=0}] run tag @e[tag=gamestarted] remove gamestarted

#bridge blocks
execute as @a[gamemode=adventure] at @s if block ~ ~-2 ~ bone_block run function boxrush:blocks

#bridge spawner unblocker
execute at @e[tag=spawner] unless block ~ ~-1 ~ air run setblock ~ ~-1 ~ air

#swim
execute as @a[gamemode=adventure] at @s if block ~ ~ ~ water run effect give @s water_breathing 2 1 true

#archer
execute at @e[tag=target1] if block ~ ~-1 ~ target[power=12] run fill ~-1 ~-5 ~-1 ~1 ~-5 ~1 spruce_planks
execute at @e[tag=target2] if block ~ ~-1 ~ target[power=12] run fill ~-1 ~-8 ~-1 ~1 ~-8 ~1 spruce_planks
execute at @e[tag=target3] if block ~ ~-1 ~ target[power=12] run fill ~-1 ~-12 ~-1 ~1 ~-12 ~1 spruce_planks
execute at @e[tag=target1] if block ~ ~-1 ~ target[power=13] run fill ~-1 ~-5 ~-1 ~1 ~-5 ~1 spruce_planks
execute at @e[tag=target2] if block ~ ~-1 ~ target[power=13] run fill ~-1 ~-8 ~-1 ~1 ~-8 ~1 spruce_planks
execute at @e[tag=target3] if block ~ ~-1 ~ target[power=13] run fill ~-1 ~-12 ~-1 ~1 ~-12 ~1 spruce_planks
execute at @e[tag=target1] if block ~ ~-1 ~ target[power=14] run fill ~-1 ~-5 ~-1 ~1 ~-5 ~1 spruce_planks
execute at @e[tag=target2] if block ~ ~-1 ~ target[power=14] run fill ~-1 ~-8 ~-1 ~1 ~-8 ~1 spruce_planks
execute at @e[tag=target3] if block ~ ~-1 ~ target[power=14] run fill ~-1 ~-12 ~-1 ~1 ~-12 ~1 spruce_planks
execute at @e[tag=target1] if block ~ ~-1 ~ target[power=15] run fill ~-1 ~-5 ~-1 ~1 ~-5 ~1 spruce_planks
execute at @e[tag=target2] if block ~ ~-1 ~ target[power=15] run fill ~-1 ~-8 ~-1 ~1 ~-8 ~1 spruce_planks
execute at @e[tag=target3] if block ~ ~-1 ~ target[power=15] run fill ~-1 ~-12 ~-1 ~1 ~-12 ~1 spruce_planks
execute as @e[tag=target] at @s if block ~ ~-1 ~ target[power=12] run kill @s
execute as @e[tag=target] at @s if block ~ ~-1 ~ target[power=13] run kill @s
execute as @e[tag=target] at @s if block ~ ~-1 ~ target[power=14] run kill @s
execute as @e[tag=target] at @s if block ~ ~-1 ~ target[power=15] run kill @s

#elytra
execute as @a[gamemode=adventure] at @s if block ~ ~-1.5 ~ end_stone run function boxrush:elytra
execute as @a[gamemode=adventure] at @s if entity @e[tag=ElytraGold,distance=..1] run scoreboard players add @s elytraPoints 1
execute as @a[gamemode=adventure] at @s at @e[tag=ElytraGold,distance=..1] run playsound block.note_block.pling voice @a[limit=1,gamemode=adventure,sort=nearest] ~ ~ ~ 1 2
execute as @a[gamemode=adventure] at @s run kill @e[tag=ElytraGold,distance=..1]
execute as @a[scores={elytraPoints=5}] at @s at @e[tag=elytraexit,sort=nearest,limit=1] run fill ~-1 ~-1 ~-1 ~1 ~-1 ~1 air

#pearl
execute as @a[gamemode=adventure,tag=!pearling] at @s if block ~ ~-2 ~ obsidian run give @s ender_pearl 1
execute as @a[gamemode=adventure] at @s if block ~ ~-2 ~ obsidian run tag @s add pearling
execute as @a[scores={usingPearl=1..}] run give @s ender_pearl 1
execute as @a[scores={usingPearl=1..}] run scoreboard players remove @s usingPearl 1

#items thrown
kill @e[type=item]
execute as @a[tag=pearling,scores={pearlThrown=1..}] run give @s ender_pearl 1
execute as @a[scores={pearlThrown=1..}] run scoreboard players remove @s pearlThrown 1 

#resistance
effect give @a resistance 1 5 true